program     CDEMO;
(**********************   CDEMO.DPR   ************************************
*                                                                        *
*                Simple Demo Program for                                 *
*                       C M A T H                                        *
*                                                                        *
*  Copyright 1996-2012 by OptiCode - Dr. Martin Sander Software Dev.     *
*                                                                        *
*       This sample program provides a very basic test                   *
*       for the correct installation of CMATH and for                    *
*       correct error handling.                                          *
*                                                                        *
**************************************************************************)

(*
    64-bit (RAD Studio XE2 or higher):
    Open CDEMO.dproj in RAD Studio, compile and run.

    32-bit:
    Open this file as a project in the Delphi IDE
    and add \YourCMATHDirectory\LIB to the search path in
    Project / Options / Directories and Conditionals / Search path.
    With the registered version, write "LIB4" or "LIB6" instead of "LIB"

    Alternatively, compile this demo program from the command-line as
    DCC32 -u"\YourCMATHDirectory\LIB" CDEMO.DPR
    and run the resulting CDEMO.EXE.
*)

{$E-} {$N+} {$D+}
uses CMATH, SysUtils;

var  x, y: fComplex;
     Msg, Msg1, Msg2:  array[0..120] of char;
     SMsg1, SMsg2:     String[120];
begin
    V_printErrorMsg( 'Welcome to the CMATH installation check!'#13#13+
                     'Do not wonder, the next window shows'#13+
                     'a piece of error handling (with error'#13+
                     'message for Win32, silently for Win64)!');
    x.Re := 3;
    x.Im := 5;   {first method of initialization}
    fcplx( y, 0, 0 );  {second method of initialization}
    cf_sin( x, x );  { type-specific function-call form: most efficient way}
    y := inv( y );  { overloaded function and := operator - more intuitive,
                      but less efficient!
                      This call will produce an error message in Win32. }
                    { now primitive way to show results }
    Str( x.Re, SMsg1 ); Str( x.Im, SMsg2 );
    StrPCopy( Msg1, SMsg1 ); StrPCopy( Msg2, SMsg2 );
    StrECopy( StrECopy( StrECopy( StrECopy( Msg, 'The sine of { 3.0, 5.0 } is'#13+'{ ' ), Msg1 ), ', ' ), Msg2 );
    StrCat( Msg, ' }' );  V_printErrorMsg( Msg );
    Str( y.Re, SMsg1 ); Str( y.Im, SMsg2 );
    StrPCopy( Msg1, SMsg1 ); StrPCopy( Msg2, SMsg2 );
    StrECopy( StrECopy( StrECopy( StrECopy( Msg, 'Within Single accuracy, complex 1/0 situations yield'#13+'{ ' ), Msg1 ), ', ' ), Msg2 );
    StrCat( Msg, ' }' );  V_printErrorMsg( Msg );
    V_printErrorMsg( 'Thank you!'#13+
                     'Enjoy using CMATH in your programs!' );
end.
